;
; Hacks DIGGER.EXE lives in DosBox emulation
;
; assemble with "nasm -f bin -o lives.com lives.asm"
;
; run in .bat before DIGGER.EXE 
;

	org 0x100		; .com files always start 256 bytes into the segment

	jmp Setup

Start:

; Hooked timer interrupt. Hook Int09 for keyboard.
MyInt08:
	
	pushf
	push	ax
	push	bp
	push	ds

	mov bp, 01E22h		; DS:1E22 are lives while running DIGGER.EXE
	mov	ax, 0255Ah		; But be sure DS = 255A for DIGGER.EXE, as it is in DosBox debug
	mov	ds,ax
	mov	byte ds:bp, 250		; Keep lives constant 250 at at address DS:01E22

	pop	ds
	pop	bp
	pop	ax
	popf

	; now jump to the hooked interrupt
	
	db	0xEA	; JMP FAR 0000:0000 opcode for x86
old_IP:	dw	0		; Keep address of hooked interrupt
old_CS	dw	0

	;iret

	; Resident part ends here.
Setup:

	; CS=0	 as address is 100h
	
	mov ax,cs
	mov ds,ax		; DS=0
	
	push es
	mov	ax, 0x3508	; Get Interrupt Vector
	int 0x21		; call dos services
	mov [old_CS], es	; save hooked interrupt address
	mov [old_IP], bx
	pop es
	
	lea	dx, MyInt08 ; my hooked timer interrupt
	mov	ax, 0x2508	; Set Interrupt Vector
	int 0x21		; call dos services		
	mov dx, (256+Setup-Start+15)/16
	mov ax, 0x3100	; "terminate program, stay resident" sub-function, return code 0
	sti				; enable interrupts
	int 0x21		; call dos services

End:
	nop
	